//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%46D84FD702E5.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%46D84FD702E5.cm

//## begin module%46D84FD702E5.cp preserve=no
//## end module%46D84FD702E5.cp

//## Module: FITSChain%46D84FD702E5; Package body
//## Subsystem: XSFit::MCMC%41E6AA18032C
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/MCMC/FITSChain.cxx

//## begin module%46D84FD702E5.additionalIncludes preserve=no
//## end module%46D84FD702E5.additionalIncludes

//## begin module%46D84FD702E5.includes preserve=yes
#include <CCfits/CCfits>
#include <XSContainer.h>
#include <XSstreams.h>
#include <XSFit/Fit/Fit.h>
#include <XSFit/Fit/StatMethod.h>
#include <XSFit/MCMC/Chain.h>
#include <XSFit/MCMC/ChainManager.h>
#include <XSFit/MCMC/FITSChain.h>
#include <XSModel/Data/DataUtility.h>
#include <XSModel/GlobalContainer/DataContainer.h>
#include <XSModel/GlobalContainer/ModelContainer.h>
#include <XSModel/Model/Model.h>
#include <XSUtil/Parse/XSparse.h>
#include <XSUtil/Utils/XSstream.h>
#include <XSUtil/Utils/XSutility.h>
#include <sstream>
#include <fstream>
//## end module%46D84FD702E5.includes

//## begin module%46D84FD702E5.declarations preserve=no
//## end module%46D84FD702E5.declarations

//## begin module%46D84FD702E5.additionalDeclarations preserve=yes
//## end module%46D84FD702E5.additionalDeclarations


// Class FITSChain 

//## begin FITSChain::FORMATNAME%46DDBC0F012D.attr preserve=no  public: static const string {U} string("fits")
const string FITSChain::s_FORMATNAME = string("fits");
//## end FITSChain::FORMATNAME%46DDBC0F012D.attr

//## begin FITSChain::EXTNAME%46E17014013B.attr preserve=no  private: static string {UC} string("CHAIN")
const string FITSChain::s_EXTNAME = string("CHAIN");
//## end FITSChain::EXTNAME%46E17014013B.attr

//## begin FITSChain::TEMPERKEY%46E170C70387.attr preserve=no  private: static string {UC} string("TEMPR")
const string FITSChain::s_TEMPERKEY = string("TEMPR");
//## end FITSChain::TEMPERKEY%46E170C70387.attr

//## begin FITSChain::ROWKEY%46E1712902C7.attr preserve=no  private: static string {UC} string("STROW")
const string FITSChain::s_ROWKEY = string("STROW");
//## end FITSChain::ROWKEY%46E1712902C7.attr

//## begin FITSChain::FLOATTYPE%46E1718403C1.attr preserve=no  private: static string {UC} string("D")
const string FITSChain::s_FLOATTYPE = string("D");
//## end FITSChain::FLOATTYPE%46E1718403C1.attr

//## begin FITSChain::STATCOL%46E1720B00A6.attr preserve=no  private: static string {UC} string("FIT_STATISTIC")
const string FITSChain::s_STATCOL = string("FIT_STATISTIC");
//## end FITSChain::STATCOL%46E1720B00A6.attr

//## begin FITSChain::TEMPERDIGITS%46E188C40304.attr preserve=no  private: static size_t {UC} 3
const size_t FITSChain::s_TEMPERDIGITS = 3;
//## end FITSChain::TEMPERDIGITS%46E188C40304.attr

//## begin FITSChain::COLNAMEDELIM%46EE8DB6021B.attr preserve=no  private: static string {UC} string("__")
const string FITSChain::s_COLNAMEDELIM = string("__");
//## end FITSChain::COLNAMEDELIM%46EE8DB6021B.attr

FITSChain::FITSChain (string fileName)
  //## begin FITSChain::FITSChain%46DDB6A80339.hasinit preserve=no
  //## end FITSChain::FITSChain%46DDB6A80339.hasinit
  //## begin FITSChain::FITSChain%46DDB6A80339.initialization preserve=yes
  : m_chain(0), //non-owning
    m_iRow(1),
    m_doFileFlush(false),
    m_fits(0)
  //## end FITSChain::FITSChain%46DDB6A80339.initialization
{
  //## begin FITSChain::FITSChain%46DDB6A80339.body preserve=yes
   if (fileName.length())
   {
      // We are attempting to load an already existing chain file,
      // but we don't yet know if its format is FITS.  This is
      // just a simple test, after which we close the file.
      try
      {
         m_fits = new CCfits::FITS(fileName, CCfits::Read);
         delete m_fits;
         m_fits = 0;
      }
      catch (...)
      {
         throw YellowAlert();
      }
   }
  //## end FITSChain::FITSChain%46DDB6A80339.body
}


FITSChain::~FITSChain()
{
  //## begin FITSChain::~FITSChain%46DD8511002A_dest.body preserve=yes
   delete m_fits;
  //## end FITSChain::~FITSChain%46DD8511002A_dest.body
}



//## Other Operations (implementation)
void FITSChain::doOpenForReadPoints () const
{
  //## begin FITSChain::doOpenForReadPoints%46DD8BCA0282.body preserve=yes
   try
   {
      m_fits = new CCfits::FITS(m_chain->getFileName(), CCfits::Read, s_EXTNAME);
      m_iRow = 1;
   }
   catch (CCfits::FitsException&)
   {
      // Should really never get in here since file ought to have
      // been checked by createFile or readFileInfo.
      std::ostringstream oss;
      oss << "File re-open failure in FITSChain::doOpenForReadPoints: "
         << m_chain->getFileName();
      throw RedAlert(oss.str());
   }
  //## end FITSChain::doOpenForReadPoints%46DD8BCA0282.body
}

void FITSChain::doCloseFile () const
{
  //## begin FITSChain::doCloseFile%46DD8BD1010B.body preserve=yes
   delete m_fits;
   m_fits = 0;
  //## end FITSChain::doCloseFile%46DD8BD1010B.body
}

void FITSChain::doOpenForWrite ()
{
  //## begin FITSChain::doOpenForWrite%46DF24DD00B3.body preserve=yes
   try
   {
      m_fits = new CCfits::FITS(m_chain->getFileName(), CCfits::Write, s_EXTNAME);
   }
   catch (CCfits::FitsException&)
   {
      string errMsg("While attempting to open file ");
      errMsg += m_chain->getFileName();
      errMsg += " for writing.";
      throw ChainIOError(errMsg);
   }
  //## end FITSChain::doOpenForWrite%46DF24DD00B3.body
}

void FITSChain::doReadPoint (std::vector<Real>& chainVals) const
{
  //## begin FITSChain::doReadPoint%46DD8BD700B2.body preserve=yes
   using namespace CCfits;
   // Assumes m_fits points to a valid FITS object open for reading.
   if (m_iRow > static_cast<long>(m_chain->length()))
   {
      // This can happen if someone were to externally modify
      // the chain file after loading or writing it.  So could
      // lots of other bad things.
      std::ostringstream oss;
      oss << "Attempting to read row " << m_iRow << " during sequential chain read."
        <<"\n   This is beyond end of table in file " << m_chain->getFileName();
      throw ChainIOError(oss.str());
   }
   const size_t nVals = m_chain->width();
   chainVals.resize(nVals, .0);
   fitsfile* fptr = m_fits->currentExtension().fitsPointer();
   int status = 0;
   int anynul = 0;
   for (int i=0; i<static_cast<int>(nVals); ++i)
   {
      fits_read_col_dbl(fptr, i+1, m_iRow, 1, 1, 0, &chainVals[i], &anynul, &status);
   }
   ++m_iRow;
  //## end FITSChain::doReadPoint%46DD8BD700B2.body
}

void FITSChain::doReadPointFromLine (size_t lineNum, RealArray& parVals) const
{
  //## begin FITSChain::doReadPointFromLine%46DD8BDF0088.body preserve=yes
   // Assumes m_fits is already open and parVals is the proper size.
   const size_t nPars = parVals.size();
   long longLineNum = static_cast<long>(lineNum);
   if (nPars+1 != m_chain->width())
   {
      throw RedAlert("Parameter array size mismatch with chain file.");
   }
   if (lineNum < 1 || lineNum > m_chain->length())
   {
      std::ostringstream oss;
      oss << "Attempting to read row " << lineNum << " during random-access chain read."
         <<"\n   This is beyond end of table in file " << m_chain->getFileName();
      throw ChainIOError(oss.str());
   }
   fitsfile* fptr = m_fits->currentExtension().fitsPointer();
   int status = 0;
   int anynul = 0;
   for (int i=0; i<static_cast<int>(nPars); ++i)
   {
      fits_read_col_dbl(fptr, i+1, longLineNum, 1, 1, 0, &parVals[i], &anynul, &status);
   }
   if (status)
   {
      string errMsg("While attempting to read parameter values from ");
      errMsg += m_chain->getFileName();
      throw ChainIOError(errMsg);
   }
  //## end FITSChain::doReadPointFromLine%46DD8BDF0088.body
}

const string& FITSChain::getFormatName () const
{
  //## begin FITSChain::getFormatName%46DDC05F033A.body preserve=yes
   return s_FORMATNAME;
  //## end FITSChain::getFormatName%46DDC05F033A.body
}

void FITSChain::readFileInfo ()
{
  //## begin FITSChain::readFileInfo%46E06B4602ED.body preserve=yes
  using namespace CCfits;
  string errLabel(s_EXTNAME);
  errLabel += " extension";
  try
  {
     m_fits = new FITS(m_chain->getFileName(), Read, s_EXTNAME);
     ExtHDU& ext = m_fits->extension(s_EXTNAME);
     Table* table = dynamic_cast<Table*>(&ext);
     if (!table)
     {
        string msg(errLabel);
        msg += "is not a table in ";
        msg += m_chain->getFileName();
        throw ChainIOError(msg);
     }
     
     errLabel = "NAXIS2 keyword";
     // Shouldn't trust Table::rows() since we go into cfitsio
     // directly with column reads and writes.
     int status=0;
     long nRows=0;
     fitsfile* fptr = m_fits->currentExtension().fitsPointer();
     fits_get_num_rows(fptr, &nRows, &status);
     if (!nRows)
        throw YellowAlert("Chain length must be > 0\n");
     if (status)
        throw FitsError(status,true);
     m_chain->length(nRows);
     
     errLabel = "number of columns";
     m_chain->width(table->column().size());
     if (m_chain->width() < 2)
        throw YellowAlert("Chain tables must have at least 2 columns.\n");
     
     // The following 2 functions should only throw YellowAlerts,
     // not FitsExceptions.   
     readTemperInfo(table);  
     readParamInfo(table);      

     delete m_fits;
     m_fits = 0;
  }
  catch (FitsException&)
  {
     string msg("while attempting to read ");
     msg += errLabel + " in ";
     msg += m_chain->getFileName();
     delete m_fits;
     m_fits = 0;
     throw ChainIOError(msg);
  }
  catch (YellowAlert&)
  {
     delete m_fits;
     m_fits = 0;
     throw;
  }
  //## end FITSChain::readFileInfo%46E06B4602ED.body
}

void FITSChain::createFile ()
{
  //## begin FITSChain::createFile%46E157A600DE.body preserve=yes
   using namespace CCfits;
   try
   {
      string rmString("rm -f ");
      std::ifstream testFile(m_chain->getFileName().c_str());
      if (testFile)
      {
         // We must ASSUME by this point that the user has been
         // notified of a pre-existing file and has given the OK
         // to replace it.
         rmString += m_chain->getFileName();
         std::system(rmString.c_str());
      }
      m_fits = new FITS(m_chain->getFileName(), Write);
      // To view FITS chain in progress, writePoint must call
      // for a file flush AFTER the first line is written.
      // It will need to do it again if appending.
      m_doFileFlush = true; 
   }
   catch (FitsException&)
   {
      string msg("Unable to create output FITS file ");
      msg += m_chain->getFileName();
      m_fits = 0;
      throw ChainIOError(msg);
   }
   int savConVerbose = tpout.conVerbose();
   int savLogVerbose = tpout.logVerbose();
   XSstream::verbose(tpout,25,25);
   tcout << "Writing chain to " << m_chain->getFileName() << std::endl;
   XSstream::verbose(tpout, savConVerbose, savLogVerbose);
  //## end FITSChain::createFile%46E157A600DE.body
}

void FITSChain::writePoint ()
{
  //## begin FITSChain::writePoint%46E157C00124.body preserve=yes
  // Function assumes m_fits is open and ready for writing.  
  // NOTE: If anything changes in here, doReadPointFromLine
  // may need a corresponding readjustment.
  using namespace XSContainer;
  
//  CCfits::Table& table = static_cast<CCfits::Table&>(m_fits->extension(s_EXTNAME));
//  long iRow = table.rows() + 1;
//  table.insertRows(iRow-1, 1);
  const std::map<int,ModParam*>& varPars = fit->variableParameters();
  std::map<int,ModParam*>::const_iterator it = varPars.begin();
  std::map<int,ModParam*>::const_iterator itEnd = varPars.end();
  int iCol = 1;
  int status = 0;
  fitsfile* fptr = m_fits->currentExtension().fitsPointer();
  long iRow = 1;
  fits_get_num_rows(fptr, &iRow, &status);
  ++iRow;
  while (it != itEnd)
  {
 //    CCfits::Column& column = table.column(iCol);
     Real val = it->second->value();
//     column.write(&val, (long)1, iRow);
     fits_write_col_dbl(fptr, iCol, iRow, 1, 1, &val, &status);
     ++it, ++iCol;
  }
  Real statVal = fit->statistic(); 
//  table.column(iCol).write(&statVal, (long)1, iRow); 
   fits_write_col_dbl(fptr, iCol, iRow, 1, 1, &statVal, &status);
   if (m_doFileFlush)
   {
      fits_flush_file(fptr, &status);
      m_doFileFlush = false;
   }
   else
   {
      fits_flush_buffer(fptr, 0, &status);
      char updateKey[] = "NAXIS2";
      fits_update_key(fptr, TLONG, updateKey, &iRow, 0, &status);
   }
  //## end FITSChain::writePoint%46E157C00124.body
}

void FITSChain::writeFileInfo ()
{
  //## begin FITSChain::writeFileInfo%46E157B1011A.body preserve=yes
   using namespace CCfits;
   // Assumes new file is open and ready for writing.
   const std::vector<Chain::ParamID>& parIDs = m_chain->paramIDs();
   const size_t nCols = parIDs.size() + 1;
   std::vector<string> colName(nCols);
   std::vector<string> colFmt(nCols, s_FLOATTYPE);
   std::vector<string> colUnit(nCols);
   
   for (size_t i=0; i<parIDs.size(); ++i)
   {
      const Chain::ParamID& parID = parIDs[i];
      std::ostringstream ssIndex;
      ssIndex << parID.parName << s_COLNAMEDELIM;            
      if (parID.modName != Model::DEFAULT())
      {
         ssIndex << parID.modName << s_COLNAMEDELIM;
      }
      ssIndex << parID.index;
      colName[i] = ssIndex.str();
      colUnit[i] = parID.units;
   }
   colName[nCols-1] = s_STATCOL;
   colUnit[nCols-1] = Fit::Instance(string(""), string(""))->statMethod()->fullName();
   
   // Due to possible ctrl-C interrupt, we don't know how
   // many rows to set at this point.
   m_fits->addTable(s_EXTNAME, 0, colName, colFmt, colUnit);
   adjustTemperInfo();
   writeHistory(false);
  //## end FITSChain::writeFileInfo%46E157B1011A.body
}

void FITSChain::appendFile (RealArray& startingVals)
{
  //## begin FITSChain::appendFile%46E1583300A5.body preserve=yes
  // ASSUMES calling function has already saved the original
  // parameter values, and so is capable of restoring
  // them.  
  
  // Starting point should be the last set of values in the file.
   doOpenForWrite();
   writeHistory(true);
   startingVals.resize(m_chain->width()-1, .0);
   try
   {
      doReadPointFromLine(m_chain->length()-1, startingVals);
      // To view in-progress in fv, need to flush file
      // after first appended line is written in writePoint.
      m_doFileFlush = true;             
   }
   catch (YellowAlert&)
   {
      delete m_fits;
      m_fits = 0;
      throw;
   }
  //## end FITSChain::appendFile%46E1583300A5.body
}

void FITSChain::adjustTemperInfo ()
{
  //## begin FITSChain::adjustTemperInfo%46E1583D0088.body preserve=yes
   // Assumes m_fits is open and that newest temperature has just
   // been entered into chain's tempering array.
   const Chain::TemperInfoContainer& tempers = m_chain->tempering();
   CCfits::ExtHDU& table = m_fits->extension(s_EXTNAME);
   const string comment("");
   int iTemp = tempers.size();  // iTemp is 1-based
   const string keyIdx(intToKeyIndex(iTemp));
   const string tempKeyword(s_TEMPERKEY+keyIdx);
   const string rowKeyword(s_ROWKEY+keyIdx);
   table.addKey(tempKeyword, tempers[iTemp-1].second, comment);
   table.addKey(rowKeyword, tempers[iTemp-1].first, comment);
  //## end FITSChain::adjustTemperInfo%46E1583D0088.body
}

bool FITSChain::checkTemperField (const Real temperature) const
{
  //## begin FITSChain::checkTemperField%46E84191015D.body preserve=yes
   // Can we add 1 more temperature keyword?
   // The actual input temperature arg is irrelevant here.
   size_t upperLimit = 1;
   for (size_t i=0; i<s_TEMPERDIGITS; ++i)
      upperLimit *= 10;
   return (m_chain->tempering().size() < upperLimit-1);
  //## end FITSChain::checkTemperField%46E84191015D.body
}

void FITSChain::setParent (Chain* chain)
{
  //## begin FITSChain::setParent%46DDB42903D8.body preserve=yes
   m_chain = chain;
  //## end FITSChain::setParent%46DDB42903D8.body
}

string FITSChain::intToKeyIndex (int iEntry)
{
  //## begin FITSChain::intToKeyIndex%46E1B513011D.body preserve=yes
   std::ostringstream intString;
   int upperLimit = 1;
   for (size_t i=0; i<s_TEMPERDIGITS; ++i)
      upperLimit *= 10;
   if (iEntry > 0 && iEntry < upperLimit)
   {
      int iPow = static_cast<int>(std::log10((Real)iEntry));
      for (int i=static_cast<int>(s_TEMPERDIGITS-1); i>iPow; --i)
         intString << "0";
      intString << iEntry;
   }   
   return intString.str();
  //## end FITSChain::intToKeyIndex%46E1B513011D.body
}

void FITSChain::readTemperInfo (CCfits::Table* table)
{
  //## begin FITSChain::readTemperInfo%46E56E8F0315.body preserve=yes
   using namespace CCfits;
   Chain::TemperInfoContainer temperArray;
   try
   {
      // Keep reading TEMPR/STROW pairs until no more can be found.
      // There must be a least one of these.
      int upperLimit = 1;
      for (size_t i=0; i<s_TEMPERDIGITS; ++i)
         upperLimit *= 10;
      int iEntry = 1;
      while (iEntry < upperLimit)
      {
         string tempKey(s_TEMPERKEY);
         string rowKey(s_ROWKEY);
         string suffix(intToKeyIndex(iEntry));
         tempKey += suffix;
         rowKey += suffix;
         Real tempVal = 0.0;
         int rowVal = 0;
         table->readKey(tempKey, tempVal);
         table->readKey(rowKey, rowVal);
         if (tempVal <= 0.0)
         {
            std::ostringstream oss;
            oss << "Invalid " << tempKey << " value: " << tempVal 
              << " in file " << m_chain->getFileName() <<"\n";
            throw YellowAlert(oss.str());
         }
         if (rowVal < 1 || static_cast<size_t>(rowVal) > m_chain->length())
         {
            std::ostringstream oss;
            oss << "Invalid " << rowKey << " value: " << rowVal 
                << " in file " << m_chain->getFileName() <<"\n";
            throw YellowAlert(oss.str());
         }
         temperArray.push_back(std::make_pair(static_cast<size_t>(rowVal), tempVal));
         ++iEntry;
      }
   }
   catch (FitsException&)
   {
      // A FitsException is to be expected.  This is how it
      // exits the keywords loop.
      if (temperArray.empty())
      {
         string errMsg("At least 1 pair of ");
         errMsg += s_TEMPERKEY + " and " + s_ROWKEY;
         errMsg += " keywords are required in file ";
         errMsg + m_chain->getFileName() + "\n";
         throw YellowAlert(errMsg);
      }
   }
   m_chain->tempering(temperArray);
  //## end FITSChain::readTemperInfo%46E56E8F0315.body
}

void FITSChain::readParamInfo (CCfits::Table* table)
{
  //## begin FITSChain::readParamInfo%46E58D8603D2.body preserve=yes
   // Chain width should already have been set to the number of
   // columns in the table, and must be at least 2 if it got to 
   // this point.
   const int nPars = static_cast<int>(m_chain->width())-1;
   if (nPars < 1)
      throw RedAlert("Chain width error in FITSChain::readParamInfo.");
   std::vector<Chain::ParamID> paramIDs((size_t)nPars);
   bool isLabelErr = false;
   int iCol = 1;
   while (iCol <= nPars)
   {
      Chain::ParamID& inPar = paramIDs[iCol-1];
      const CCfits::Column& column = table->column(iCol);
      const string& colName = column.name();
      const string& colFormat = column.format();
      const string& colUnits = column.unit();
      if (colFormat != s_FLOATTYPE)
      {
         std::ostringstream oss;
         oss << "Column " << iCol << " in chain extension of file "
           << m_chain->getFileName() << "\n    is the wrong format type.";
         throw ChainIOError(oss.str());
      }
      
      // Label format should be  <parName>__[<modName>__]<parIndex>
      const string WS(" \t");
      string paramIndex;
      string paramName;
      string modelName;
      size_t index = string::npos;
      string::size_type iPos = colName.find_first_not_of(WS);
      if (iPos == string::npos)
      {
         isLabelErr = true;
         break;
      }
      string::size_type delimPos = colName.find(s_COLNAMEDELIM, iPos);
      if (delimPos == string::npos)
      {
         isLabelErr = true;
         break;
      }
      paramName = colName.substr(iPos, delimPos - iPos);
      
      // If no more delimiters, remainder of string should just be an index.
      iPos = delimPos + s_COLNAMEDELIM.size();
      delimPos = colName.find(s_COLNAMEDELIM, iPos);
      if (delimPos != string::npos)
      {
         modelName = colName.substr(iPos, delimPos - iPos);
         iPos = delimPos + s_COLNAMEDELIM.size();
      }
      paramIndex = colName.substr(iPos);
      index = XSutility::isInteger(paramIndex);
      if (index == string::npos)
      {
         isLabelErr = true;
         break;
      }
      
      inPar.index = index;
      inPar.modName = modelName.length() ? modelName : Model::DEFAULT();
      inPar.parName = paramName;
      inPar.units = colUnits; 
      ++iCol;     
   } // end par loop
   if (isLabelErr)
   {
      std::ostringstream oss;
      oss << "Column " << iCol << " has an invalid parameter label "
          << "\n   in chain extension of file " << m_chain->getFileName();
      throw ChainIOError(oss.str());
   }
   
   m_chain->paramIDs(paramIDs);
   
   const CCfits::Column& column = table->column(nPars+1);
   if (column.format() != s_FLOATTYPE)
   {
      std::ostringstream oss;
      oss << "Column " << nPars+1 << " in chain extension of file "
        << m_chain->getFileName() << "\n    is the wrong format type.";
      throw ChainIOError(oss.str());
   }
   if (column.name() != s_STATCOL)
   {
      std::ostringstream oss;
      oss << "Column " << nPars+1 << " in chain extension of file "
        << m_chain->getFileName() << "\n    should have label "
        << s_STATCOL;
      throw ChainIOError(oss.str());
   }
   m_chain->statistic(column.unit());
  //## end FITSChain::readParamInfo%46E58D8603D2.body
}

void FITSChain::writeHistory (bool isAppend) const
{
  //## begin FITSChain::writeHistory%46EEEBA10157.body preserve=yes
   using namespace std;
   using namespace XSContainer;
   tcout.flush();
   
   // The various data/model report functions are hardcoded to write
   // to tcout.  We can reroute and grab the output by temporarily
   // replacing tcout's streambuf (type XSstreambuf) with a
   // stringbuf (the type of streambuf used by stringstreams).  

   // Make sure chatter levels are no higher than 10, otherwise
   // data output will include grouping map.
   const int savConChatter = tpout.consoleChatterLevel();
   const int savLogChatter = tpout.logChatterLevel();
   tpout.consoleChatterLevel(10);
   tpout.logChatterLevel(10);
   
   stringbuf strBuf;
   streambuf* saveStreamBuf = tcout.rdbuf(&strBuf);
   try
   {
      const size_t fieldWidth = 72;
      
      char datetime[20];
      int timeref=0, status=0;
      if (fits_get_system_time(datetime, &timeref, &status))
      {
         throw YellowAlert("Unable to read system time\n");
      }
      string history;
      CCfits::ExtHDU& chainExt = m_fits->currentExtension();
      if (isAppend)
      {
         ostringstream oss;
         oss << "Appended to XSPEC chain after line " << m_chain->length();
         chainExt.writeComment("   ");
         history = oss.str();
      }
      else
      {
         history = "Created by XSPEC's chain run command";
      }
      chainExt.writeHistory(history);
      chainExt.writeHistory(string(datetime));
      
      fit->chainManager()->reportChainProposal();
      if (!isAppend)
         tcout << "Burn length = " << m_chain->burnLength() << endl
               <<"Chain randomization is " << (m_chain->rand() ? "on" : "off") << endl;
      datasets->showData(false);
      models->showModel(); 
      fit->statMethod()->report(fit);
      tcout << " Weighting method: " << DataUtility::statWeight().name()
          << endl;
      string::size_type iPos = 0;
      const string WS(" \t\n");
      while (iPos != string::npos)
      {
         string xspecInfo(XSparse::stringSegment(strBuf.str(), fieldWidth, &iPos));
         if (xspecInfo.find_first_not_of(WS) != string::npos)
            chainExt.writeComment(xspecInfo);
      }
   }
   catch (...)
   {
      tcout.rdbuf(saveStreamBuf);
      tpout.consoleChatterLevel(savConChatter);
      tpout.logChatterLevel(savLogChatter);
      throw ChainIOError("Error during write to COMMENTS and HISTORY section of chain extension.");
   }
   
   tcout.rdbuf(saveStreamBuf);
   tpout.consoleChatterLevel(savConChatter);
   tpout.logChatterLevel(savLogChatter);
   
  //## end FITSChain::writeHistory%46EEEBA10157.body
}

// Additional Declarations
  //## begin FITSChain%46DD8511002A.declarations preserve=yes
  //## end FITSChain%46DD8511002A.declarations

//## begin module%46D84FD702E5.epilog preserve=yes
//## end module%46D84FD702E5.epilog
